//+--------------------------------------------------------------------------------------------+
//|HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH|
//+--------------------------------------------------------------------------------------------+
//|\           \                             JS-FIBOFAN.mq4                      /           / |
//| )----)------)---------------------------------------------------------------(------(----(  |
//|/           /         js_sergey@list.ru     2009    \           \ |
//+--------------------------------------------------------------------------------------------+
//|HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH|
//+--------------------------------------------------------------------------------------------+

#property copyright " js_sergey@list.ru "
#property link      " http://multiexperts.ru/ "

#property indicator_chart_window
extern int   ExtDepth     = 24;
extern int   ExtDeviation = 12;
extern int   ExtBackstep  = 5;
//---
extern int   _f38    = 0;
extern int   _f38      = 1;
extern color _f38     = Blue;
//---
extern int   _f50    = 0;
extern int   _f50      = 1;
extern color _f50     = DarkOrange;
//---
extern int   _f61    = 0;
extern int   _f61      = 1;
extern color _f61     = Blue;
//---
extern bool   fon = false;
int rg,rd;
double f76, f61, f50, f38, ext1, ext0;
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("Fibo38");
   ObjectDelete("Fibo50");
   ObjectDelete("Fibo61");
   ObjectDelete("F38");
   ObjectDelete("F50");
   ObjectDelete("F61");
//----
   return(0);
  }
//+------------------------------------------------------------------+ 
int start()
  {
//----
   rg=GetExtremumZZBar(0);
   rd=GetExtremumZZBar(1); 
//---- 
   ext0=GetExtremumZZPrice(0);
   ext1=GetExtremumZZPrice(1);
//---- 
   f38=ext1+((ext0-ext1)*0.382); 
   f50=ext1+((ext0-ext1)*0.500);
   f61=ext1+((ext0-ext1)*0.618);
//----
   ObjectDelete("Fibo38");
   ObjectCreate("Fibo38", OBJ_TREND, 0, Time[rd], ext1, Time[rg], f61);
   ObjectSet("Fibo38", OBJPROP_STYLE, _f38);
   ObjectSet("Fibo38", OBJPROP_WIDTH, _f38); 
   ObjectSet("Fibo38", OBJPROP_COLOR, _f38);
   ObjectSet("Fibo38", OBJPROP_BACK,  fon);
//----    
   ObjectDelete("Fibo50");
   ObjectCreate("Fibo50", OBJ_TREND, 0, Time[rd], ext1, Time[rg], f50);
   ObjectSet("Fibo50", OBJPROP_STYLE, _f50);
   ObjectSet("Fibo50", OBJPROP_WIDTH, _f50); 
   ObjectSet("Fibo50", OBJPROP_COLOR, _f50);
   ObjectSet("Fibo50", OBJPROP_BACK,  fon);
//----
   ObjectDelete("Fibo61");
   ObjectCreate("Fibo61", OBJ_TREND, 0, Time[rd], ext1, Time[rg], f38);
   ObjectSet("Fibo61", OBJPROP_STYLE, _f61);
   ObjectSet("Fibo61", OBJPROP_WIDTH, _f61); 
   ObjectSet("Fibo61", OBJPROP_COLOR, _f61);
   ObjectSet("Fibo61", OBJPROP_BACK,  fon);  
//----
   double CP=5*Point;
   ObjectDelete("F61");
   ObjectCreate("F61",OBJ_TEXT,0,Time[rg],f38-CP);
   ObjectSetText("F61","F61.8",8,"Arial",_f61);
//----  
   ObjectDelete("F50");
   ObjectCreate("F50",OBJ_TEXT,0,Time[rg],f50-CP);
   ObjectSetText("F50","F50.0",8,"Arial",_f50);
//----  
   ObjectDelete("F38");
   ObjectCreate("F38",OBJ_TEXT,0,Time[rg],f61-CP);
   ObjectSetText("F38","F38.2",8,"Arial",_f38);
//----
   return(0);
  }
//+------------------------------------------------------------------+
int GetExtremumZZBar(int ne) {
  double zz;
  int i, k=iBars(Symbol(), 0), ke=0;
  for (i=0; i<k; i++) {
    zz=iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 0, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(i);
    }
  }
  return(-1);
}
//+------------------------------------------------------------------+
double GetExtremumZZPrice(int ne) {
  double zz;
  int    i, k=iBars(Symbol(), 0), ke=0;
  for (i=0; i<k; i++) {
    zz=iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 0, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(zz);
    }
  }
  return(0);
}
//+------------------------------------------------------------------+